package csvparser

import (
	"fmt"
	"strings"
	"unicode/utf8"
)

type Parser struct {
	enclosers []string
	delimiter rune
	fields    []string
}

func (p *Parser) Initialize(delimiter string, enclosers []string, lineFormat string) error {
	if utf8.RuneCountInString(delimiter) != 1 {
		return fmt.Errorf("delimiter shoud be one character")
	}
	p.enclosers = make([]string, 0)
	for _, encloser := range enclosers {
		if utf8.RuneCountInString(encloser) != 2 {
			return fmt.Errorf("encolser should have to characters")
		}
	}
	p.enclosers = enclosers
	p.delimiter = []rune(delimiter)[0]
	for _, pair := range enclosers {
		if utf8.RuneCountInString(pair) != 2 {
			return fmt.Errorf("encoloser should contain two characters: %s", pair)
		}
	}
	// line format is in the form of: field1 field2 ignore ...
	// if field name is ignore, it is parsed but not retained
	p.fields = strings.Split(lineFormat, " ")

	return nil
}

func (p *Parser) Parse(line string) (map[string]string, error) {
	currentFieldIndex := 0
	ret := make(map[string]string)
	value := ""
	for index, r := range line {
		if r == p.delimiter {
			currentFieldIndex++
			ret[p.fields[currentFieldIndex]] = value
			continue
		}
		for _, encloser := range p.enclosers {
			runes := []rune(encloser)
			if r == runes[0] {
				// opening encloser
				tmpStr := line[index:]
				for tmpIndex, tmpR := range tmpStr {
					
				}
			}
		}
	}

	return ret, nil
}
